#! /bin/bash

###########################################################################
#                                                                         #
# Copyright (C) 2010 by Benoit BALON                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
###########################################################################

function make_svg ()
{
	img=$1
	svg=${1%.???}
	png1=$2
	png2=$3
	png3=$4
	png4=$5
	png5=$6
	png6=$7
	png7=$8
	png8=$9
	png9=${10}
	
	cat << EOF > ${svg}.svg
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<svg
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:cc="http://creativecommons.org/ns#"
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:svg="http://www.w3.org/2000/svg"
   xmlns="http://www.w3.org/2000/svg"
   xmlns:xlink="http://www.w3.org/1999/xlink"
   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
   width="`identify -format '%W' $img`"
   height="`identify -format '%H' $img`"
   id="svg3642"
   sodipodi:version="0.32"
   inkscape:version="0.47 r22583"
   sodipodi:docname="${svg}"
   inkscape:output_extension="org.inkscape.output.svg.inkscape"
   version="1.0">
  <sodipodi:namedview
     pagecolor="#ffffff"
     bordercolor="#666666"
     borderopacity="1"
     objecttolerance="10"
     gridtolerance="10"
     guidetolerance="10"
     inkscape:pageopacity="0"
     inkscape:pageshadow="2"
     inkscape:window-width="1280"
     inkscape:window-height="1024"
     id="namedview20"
     showgrid="true"
     inkscape:zoom="1"
     inkscape:cx="0"
     inkscape:cy="0"
     inkscape:window-x="0"
     inkscape:window-y="0"
     inkscape:window-maximized="1"
     inkscape:current-layer="layer1">
    <inkscape:grid
       type="xygrid"
       id="grid4780" />
  </sodipodi:namedview>
  <metadata
     id="metadata24">
    <rdf:RDF>
      <cc:Work
         rdf:about="">
        <dc:format>image/svg+xml</dc:format>
        <dc:type
           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
      </cc:Work>
    </rdf:RDF>
  </metadata>
  <defs
     id="defs22">
    <marker
       inkscape:stockid="Arrow1Lend"
       orient="auto"
       refY="0.0"
       refX="0.0"
       id="Arrow1Lend"
       style="overflow:visible;">
      <path
         id="path3616"
         d="M 0.0,0.0 L 5.0,-5.0 L -12.5,0.0 L 5.0,5.0 L 0.0,0.0 z "
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1.0pt;marker-start:none;"
         transform="scale(0.8) rotate(180) translate(12.5,0)" />
    </marker>
    <marker
       inkscape:stockid="Arrow1Lstart"
       orient="auto"
       refY="0.0"
       refX="0.0"
       id="Arrow1Lstart"
       style="overflow:visible">
      <path
         id="path3613"
         d="M 0.0,0.0 L 5.0,-5.0 L -12.5,0.0 L 5.0,5.0 L 0.0,0.0 z "
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1.0pt;marker-start:none"
         transform="scale(0.8) translate(12.5,0)" />
    </marker>
    <marker
       inkscape:stockid="Arrow2Lend"
       orient="auto"
       refY="0.0"
       refX="0.0"
       id="Arrow2Lend"
       style="overflow:visible;">
      <path
         id="path3634"
         style="font-size:12.0;fill-rule:evenodd;stroke-width:0.62500000;stroke-linejoin:round;"
         d="M 8.7185878,4.0337352 L -2.2072895,0.016013256 L 8.7185884,-4.0017078 C 6.9730900,-1.6296469 6.9831476,1.6157441 8.7185878,4.0337352 z "
         transform="scale(1.1) rotate(180) translate(1,0)" />
    </marker>
    <inkscape:perspective
       id="perspective26"
       inkscape:persp3d-origin="150 : 100 : 1"
       inkscape:vp_z="300 : 150 : 1"
       inkscape:vp_y="0 : 1000 : 0"
       inkscape:vp_x="0 : 150 : 1"
       sodipodi:type="inkscape:persp3d" />
    <inkscape:perspective
       id="perspective4628"
       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
       inkscape:vp_z="1 : 0.5 : 1"
       inkscape:vp_y="0 : 1000 : 0"
       inkscape:vp_x="0 : 0.5 : 1"
       sodipodi:type="inkscape:persp3d" />
    <marker
       inkscape:stockid="Arrow1Lstart"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lstart-8"
       style="overflow:visible">
      <path
         id="path3613-4"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(0.8,0,0,0.8,10,0)" />
    </marker>
    <marker
       inkscape:stockid="Arrow1Lend"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lend-5"
       style="overflow:visible">
      <path
         id="path3616-0"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(-0.8,0,0,-0.8,-10,0)" />
    </marker>
    <inkscape:perspective
       id="perspective4628-6"
       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
       inkscape:vp_z="1 : 0.5 : 1"
       inkscape:vp_y="0 : 1000 : 0"
       inkscape:vp_x="0 : 0.5 : 1"
       sodipodi:type="inkscape:persp3d" />
    <marker
       inkscape:stockid="Arrow1Lstart"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lstart-1"
       style="overflow:visible">
      <path
         id="path3613-0"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(0.8,0,0,0.8,10,0)" />
    </marker>
    <marker
       inkscape:stockid="Arrow1Lend"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lend-6"
       style="overflow:visible">
      <path
         id="path3616-3"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(-0.8,0,0,-0.8,-10,0)" />
    </marker>
    <inkscape:perspective
       id="perspective4679"
       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
       inkscape:vp_z="1 : 0.5 : 1"
       inkscape:vp_y="0 : 1000 : 0"
       inkscape:vp_x="0 : 0.5 : 1"
       sodipodi:type="inkscape:persp3d" />
    <marker
       inkscape:stockid="Arrow1Lstart"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lstart-0"
       style="overflow:visible">
      <path
         id="path3613-6"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(0.8,0,0,0.8,10,0)" />
    </marker>
    <marker
       inkscape:stockid="Arrow1Lend"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lend-1"
       style="overflow:visible">
      <path
         id="path3616-5"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(-0.8,0,0,-0.8,-10,0)" />
    </marker>
    <inkscape:perspective
       id="perspective4679-4"
       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
       inkscape:vp_z="1 : 0.5 : 1"
       inkscape:vp_y="0 : 1000 : 0"
       inkscape:vp_x="0 : 0.5 : 1"
       sodipodi:type="inkscape:persp3d" />
    <marker
       inkscape:stockid="Arrow1Lstart"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lstart-7"
       style="overflow:visible">
      <path
         id="path3613-65"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(0.8,0,0,0.8,10,0)" />
    </marker>
    <marker
       inkscape:stockid="Arrow1Lend"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lend-69"
       style="overflow:visible">
      <path
         id="path3616-37"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(-0.8,0,0,-0.8,-10,0)" />
    </marker>
    <inkscape:perspective
       id="perspective4730"
       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
       inkscape:vp_z="1 : 0.5 : 1"
       inkscape:vp_y="0 : 1000 : 0"
       inkscape:vp_x="0 : 0.5 : 1"
       sodipodi:type="inkscape:persp3d" />
    <marker
       inkscape:stockid="Arrow1Lstart"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lstart-5"
       style="overflow:visible">
      <path
         id="path3613-2"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(0.8,0,0,0.8,10,0)" />
    </marker>
    <marker
       inkscape:stockid="Arrow1Lend"
       orient="auto"
       refY="0"
       refX="0"
       id="Arrow1Lend-54"
       style="overflow:visible">
      <path
         id="path3616-7"
         d="M 0,0 5,-5 -12.5,0 5,5 0,0 z"
         style="fill-rule:evenodd;stroke:#000000;stroke-width:1pt;marker-start:none"
         transform="matrix(-0.8,0,0,-0.8,-10,0)" />
    </marker>
  </defs>
  <g
     transform="translate(0,0)"
     inkscape:groupmode="layer"
     inkscape:label="Layer 1"
     id="layer1">
    <rect
       inkscape:label="#hint-stretch-borders"
       y="6.4216232"
       x="-165.1017"
       height="84.459747"
       width="83.81356"
       id="hint-stretch-borders"
       style="opacity:0.875;fill:#008000;fill-opacity:1;stroke:none" />
    <image
       y="0"
       x="0"
       id="topleft"
       height="`identify -format '%H' $png1`"
       width="`identify -format '%W' $png1`"
       xlink:href="data:image/png;base64,`base64 $png1`" />
    <image
       y="0"
       x="`identify -format '%W' $png1`"
       id="top"
       height="`identify -format '%H' $png2`"
       width="`identify -format '%W' $png2`"
       xlink:href="data:image/png;base64,`base64 $png2`" />
    <image
       y="0"
       x="`echo $((\`identify -format '%W' $png1\` + \`identify -format '%W' $png2\`))`"
       id="topright"
       height="`identify -format '%H' $png3`"
       width="`identify -format '%W' $png3`"
       xlink:href="data:image/png;base64,`base64 $png3`" />
    <image
       y="`identify -format '%H' $png1`"
       x="0"
       id="left"
       height="`identify -format '%H' $png4`"
       width="`identify -format '%W' $png4`"
       xlink:href="data:image/png;base64,`base64 $png4`" />
    <image
       y="`identify -format '%H' $png1`"
       x="`identify -format '%W' $png4`"
       id="center"
       height="`identify -format '%H' $png5`"
       width="`identify -format '%W' $png5`"
       xlink:href="data:image/png;base64,`base64 $png5`" />
    <image
       y="`identify -format '%H' $png1`"
       x="`echo $((\`identify -format '%W' $png4\` + \`identify -format '%W' $png5\`))`"
       id="right"
       height="`identify -format '%H' $png6`"
       width="`identify -format '%W' $png6`"
       xlink:href="data:image/png;base64,`base64 $png6`" />
    <image
       y="`echo $((\`identify -format '%H' $png1\` + \`identify -format '%H' $png4\`))`"
       x="0"
       id="bottomleft"
       height="`identify -format '%H' $png7`"
       width="`identify -format '%W' $png7`"
       xlink:href="data:image/png;base64,`base64 $png7`" />
    <image
       y="`echo $((\`identify -format '%H' $png1\` + \`identify -format '%H' $png4\`))`"
       x="`identify -format '%W' $png7`"
       id="bottom"
       height="`identify -format '%H' $png8`"
       width="`identify -format '%W' $png8`"
       xlink:href="data:image/png;base64,`base64 $png8`" />
    <image
       y="`echo $((\`identify -format '%H' $png1\` + \`identify -format '%H' $png4\`))`"
       x="`echo $((\`identify -format '%W' $png7\` + \`identify -format '%W' $png8\`))`"
       id="bottomright"
       height="`identify -format '%H' $png9`"
       width="`identify -format '%W' $png9`"
       xlink:href="data:image/png;base64,`base64 $png9`" />
    <path
       style="fill:none;stroke:#000000;stroke-width:1.50762725;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Lstart);marker-end:url(#Arrow1Lend)"
       d="m -24.152533,218.45199 0,`identify -format '%H' $png1`"
       id="hint-top-margin" />
    <path
       style="fill:none;stroke:#000000;stroke-width:1.50762725;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Lstart);marker-end:url(#Arrow1Lend)"
       d="m -24.152533,338.45198 0,`identify -format '%H' $png9`"
       id="hint-bottom-margin" />
    <path
       style="fill:none;stroke:#000000;stroke-width:1.50762725;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Lstart);marker-end:url(#Arrow1Lend)"
       d="m 7.5936566,310.19817 -`identify -format '%W' $png9`,0"
       id="hint-right-margin" />
    <path
       style="fill:none;stroke:#000000;stroke-width:1.50762725;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;marker-start:url(#Arrow1Lstart);marker-end:url(#Arrow1Lend)"
       d="m 7.5936566,430.19817 -`identify -format '%W' $png1`,0"
       id="hint-left-margin" />
    <text
       xml:space="preserve"
       style="font-size:40px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;font-family:Bitstream Vera Sans"
       x="20.169497"
       y="260.66101"
       id="text4756"><tspan
         sodipodi:role="line"
         id="tspan4758"
         x="20.169497"
         y="260.66101">hint-top-margin</tspan></text>
    <text
       xml:space="preserve"
       style="font-size:40px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;font-family:Bitstream Vera Sans"
       x="20.338991"
       y="320.96613"
       id="text4760"><tspan
         sodipodi:role="line"
         id="tspan4762"
         x="20.338991"
         y="320.96613">hint-right-margin</tspan></text>
    <text
       xml:space="preserve"
       style="font-size:40px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;font-family:Bitstream Vera Sans"
       x="20.71187"
       y="379.08475"
       id="text4764"><tspan
         sodipodi:role="line"
         id="tspan4766"
         x="20.71187"
         y="379.08475">hint-bottom-margin</tspan></text>
    <text
       xml:space="preserve"
       style="font-size:40px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;font-family:Bitstream Vera Sans"
       x="21.237291"
       y="440.47458"
       id="text4768"><tspan
         sodipodi:role="line"
         id="tspan4770"
         x="21.237291"
         y="440.47458">hint-left-margin</tspan></text>
  </g>
</svg>
EOF
}

function left_margin ()
{
	width=`identify -format '%W' $imgIn`
	echo $(( ($width - $1)/2 ))
}

function top_margin ()
{
	height=`identify -format '%H' $imgIn`
	echo $(( ($height - $1)/2 ))
}

function right_margin ()
{
	width=`identify -format '%W' $imgIn`
	echo $(( $width - $1 - `left_margin $1` ))
}

function bottom_margin ()
{
	height=`identify -format '%H' $imgIn`
	echo $(( $height - $1 - `top_margin $1` ))
}

function special_crop ()
{
	center_width=$1
	center_height=$2
	
	# top-left
	convert $imgIn -crop `left_margin $center_width`x`top_margin $center_height`+0+0 +repage ${imgIn%.???}_0.png
	
	# top
	convert $imgIn -crop ${center_width}x`top_margin $center_height`+`left_margin $center_width`+0 +repage ${imgIn%.???}_1.png
	
	# top-right
	convert $imgIn -crop `right_margin $center_width`x`top_margin $center_height`+`echo $(( \`left_margin $center_width\` + $center_width ))`+0 +repage ${imgIn%.???}_2.png
	
	# left
	convert $imgIn -crop `left_margin $center_width`x${center_height}+0+`top_margin $center_height` +repage ${imgIn%.???}_3.png
	
	# center
	convert $imgIn -crop ${center_width}x${center_height}+`left_margin $center_width`+`top_margin $center_height` +repage ${imgIn%.???}_4.png
	
	# right
	convert $imgIn -crop `right_margin $center_width`x${center_height}+`echo $(( \`left_margin $center_width\` + $center_width ))`+`top_margin $center_height` +repage ${imgIn%.???}_5.png
	
	# bottom-left
	convert $imgIn -crop `left_margin $center_width`x`bottom_margin $center_height`+0+`echo $(( \`top_margin $center_height\` + $center_height ))` +repage ${imgIn%.???}_6.png
	
	# bottom
	convert $imgIn -crop ${center_width}x`bottom_margin $center_height`+`left_margin $center_width`+`echo $(( \`top_margin $center_height\` + $center_height ))` +repage ${imgIn%.???}_7.png
	
	# bottom-right
	convert $imgIn -crop `right_margin $center_width`x`bottom_margin $center_height`+`echo $(( \`left_margin $center_width\` + $center_width ))`+`echo $(( \`top_margin $center_height\` + $center_height ))` +repage ${imgIn%.???}_8.png
}


imgIn=$1

test -f "$1" && filetype=`file -bi $1 | cut -d '/' -f1`

if test "$filetype" != "image"
then
	echo "Please use an image file as first parameter"
	exit 1
fi

if test $# -eq 1
then
	convert $imgIn -crop 3x3@ +repage +adjoin ${imgIn%.???}_%d.png
elif test $# -eq 3
then
	special_crop $2 $3
else
	echo "Invalid number of arguments"
	exit 1
fi

make_svg $imgIn `ls ${imgIn%.???}_?.png`

rm -f ${imgIn%.???}_?.png

